build.sh 20 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738
  1. #!/usr/bin/env bash
  2. # Copyright 2018 Google
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. # USAGE: build.sh product [platform] [method]
  16. #
  17. # Builds the given product for the given platform using the given build method
  18. function pod_gen() {
  19. # Call pod gen with a podspec and additional optional arguments.
  20. bundle exec pod gen --local-sources=./ --sources=https://github.com/firebase/SpecsDev.git,https://github.com/firebase/SpecsStaging.git,https://cdn.cocoapods.org/ "$@"
  21. }
  22. set -euo pipefail
  23. if [[ $# -lt 1 ]]; then
  24. cat 1>&2 <<EOF
  25. USAGE: $0 product [platform] [method]
  26. product can be one of:
  27. Firebase
  28. Firestore
  29. CombineSwift
  30. InAppMessaging
  31. Messaging
  32. MessagingSample
  33. SwiftUISample
  34. MLModelDownloaderSample
  35. RemoteConfig
  36. RemoteConfigSample
  37. Sessions
  38. Storage
  39. SymbolCollision
  40. GoogleDataTransport
  41. Performance
  42. ClientApp
  43. platform can be one of:
  44. iOS (default)
  45. iOS-device
  46. macOS
  47. tvOS
  48. watchOS
  49. catalyst
  50. visionOS
  51. method can be one of:
  52. xcodebuild (default)
  53. cmake
  54. unit
  55. integration
  56. spm
  57. Optionally, reads the environment variable SANITIZERS. If set, it is expected to
  58. be a string containing a space-separated list with some of the following
  59. elements:
  60. asan
  61. tsan
  62. ubsan
  63. EOF
  64. exit 1
  65. fi
  66. product="$1"
  67. platform="iOS"
  68. if [[ $# -gt 1 ]]; then
  69. platform="$2"
  70. fi
  71. method="xcodebuild"
  72. if [[ $# -gt 2 ]]; then
  73. method="$3"
  74. fi
  75. echo "Building $product for $platform using $method"
  76. if [[ -n "${SANITIZERS:-}" ]]; then
  77. echo "Using sanitizers: $SANITIZERS"
  78. fi
  79. scripts_dir=$(dirname "${BASH_SOURCE[0]}")
  80. firestore_emulator="${scripts_dir}/run_firestore_emulator.sh"
  81. database_emulator="${scripts_dir}/run_database_emulator.sh"
  82. system=$(uname -s)
  83. case "$system" in
  84. Darwin)
  85. xcode_version=$(xcodebuild -version | grep Xcode)
  86. xcode_version="${xcode_version/Xcode /}"
  87. xcode_major="${xcode_version/.*/}"
  88. ;;
  89. *)
  90. xcode_major="0"
  91. ;;
  92. esac
  93. # Source function to check if CI secrets are available.
  94. source scripts/check_secrets.sh
  95. # Runs xcodebuild with the given flags, piping output to xcbeautify
  96. # If xcodebuild fails with known error codes, retries once.
  97. function RunXcodebuild() {
  98. echo xcodebuild "$@"
  99. xcbeautify_cmd=(xcbeautify --renderer github-actions --disable-logging)
  100. result=0
  101. xcodebuild "$@" | tee xcodebuild.log | "${xcbeautify_cmd[@]}" \
  102. && CheckUnexpectedFailures xcodebuild.log \
  103. || result=$?
  104. if [[ $result == 65 ]]; then
  105. ExportLogs "$@"
  106. echo "xcodebuild exited with 65, retrying" 1>&2
  107. sleep 5
  108. result=0
  109. xcodebuild "$@" | tee xcodebuild.log | "${xcbeautify_cmd[@]}" \
  110. && CheckUnexpectedFailures xcodebuild.log \
  111. || result=$?
  112. fi
  113. if [[ $result != 0 ]]; then
  114. echo "xcodebuild exited with $result" 1>&2
  115. ExportLogs "$@"
  116. return $result
  117. fi
  118. }
  119. # Exports any logs output captured in the xcresult
  120. function ExportLogs() {
  121. python "${scripts_dir}/xcresult_logs.py" "$@"
  122. }
  123. function CheckUnexpectedFailures() {
  124. local log_file=$1
  125. if grep -Eq "[1-9]\d* failures \([1-9]\d* unexpected\)" "$log_file"; then
  126. echo "xcodebuild failed with unexpected failures." 1>&2
  127. return 65
  128. fi
  129. }
  130. if [[ "$xcode_major" -lt 16 && "$method" != "cmake" ]]; then
  131. echo "Unsupported Xcode major version being used: $xcode_major"
  132. exit 1
  133. else
  134. ios_flags=(
  135. -sdk 'iphonesimulator'
  136. -destination 'platform=iOS Simulator,name=iPhone 16'
  137. )
  138. watchos_flags=(
  139. -sdk 'watchsimulator'
  140. -destination 'platform=watchOS Simulator,name=Apple Watch Series 10 (42mm)'
  141. )
  142. fi
  143. ios_device_flags=(
  144. -sdk 'iphoneos'
  145. -destination 'generic/platform=iOS'
  146. )
  147. ipad_flags=(
  148. -sdk 'iphonesimulator'
  149. -destination 'platform=iOS Simulator,name=iPad Pro (9.7-inch)'
  150. )
  151. macos_flags=(
  152. -sdk 'macosx'
  153. -destination 'platform=OS X,arch=x86_64'
  154. )
  155. tvos_flags=(
  156. -sdk "appletvsimulator"
  157. -destination 'platform=tvOS Simulator,name=Apple TV'
  158. )
  159. visionos_flags=(
  160. -sdk 'xrsimulator'
  161. -destination 'platform=visionOS Simulator,name=Apple Vision Pro'
  162. )
  163. catalyst_flags=(
  164. ARCHS=x86_64 VALID_ARCHS=x86_64 SUPPORTS_MACCATALYST=YES -sdk macosx
  165. -destination platform="macOS,variant=Mac Catalyst,arch=x86_64" TARGETED_DEVICE_FAMILY=2
  166. CODE_SIGN_IDENTITY=- CODE_SIGNING_REQUIRED=NO CODE_SIGNING_ALLOWED=NO
  167. )
  168. # Compute standard flags for all platforms
  169. case "$platform" in
  170. iOS)
  171. xcb_flags=("${ios_flags[@]}")
  172. gen_platform=ios
  173. ;;
  174. iOS-device)
  175. xcb_flags=("${ios_device_flags[@]}")
  176. gen_platform=ios
  177. ;;
  178. iPad)
  179. xcb_flags=("${ipad_flags[@]}")
  180. ;;
  181. macOS)
  182. xcb_flags=("${macos_flags[@]}")
  183. gen_platform=macos
  184. ;;
  185. tvOS)
  186. xcb_flags=("${tvos_flags[@]}")
  187. gen_platform=tvos
  188. ;;
  189. watchOS)
  190. xcb_flags=("${watchos_flags[@]}")
  191. ;;
  192. visionOS)
  193. xcb_flags=("${visionos_flags[@]}")
  194. ;;
  195. catalyst)
  196. xcb_flags=("${catalyst_flags[@]}")
  197. ;;
  198. all)
  199. xcb_flags=()
  200. ;;
  201. Linux)
  202. xcb_flags=()
  203. ;;
  204. *)
  205. echo "Unknown platform '$platform'" 1>&2
  206. exit 1
  207. ;;
  208. esac
  209. xcb_flags+=(
  210. ONLY_ACTIVE_ARCH=YES
  211. CODE_SIGNING_REQUIRED=NO
  212. CODE_SIGNING_ALLOWED=YES
  213. COMPILER_INDEX_STORE_ENABLE=NO
  214. )
  215. source scripts/buildcache.sh
  216. xcb_flags=("${xcb_flags[@]}" "${buildcache_xcb_flags[@]}")
  217. # TODO(varconst): Add --warn-unused-vars and --warn-uninitialized.
  218. # Right now, it makes the log overflow on Travis because many of our
  219. # dependencies don't build cleanly this way.
  220. cmake_options=(
  221. -Wdeprecated
  222. -DCMAKE_BUILD_TYPE=Debug
  223. )
  224. if [[ -n "${SANITIZERS:-}" ]]; then
  225. for sanitizer in $SANITIZERS; do
  226. case "$sanitizer" in
  227. asan)
  228. xcb_flags+=(
  229. -enableAddressSanitizer YES
  230. )
  231. cmake_options+=(
  232. -DWITH_ASAN=ON
  233. )
  234. ;;
  235. tsan)
  236. xcb_flags+=(
  237. -enableThreadSanitizer YES
  238. )
  239. cmake_options+=(
  240. -DWITH_TSAN=ON
  241. )
  242. ;;
  243. ubsan)
  244. xcb_flags+=(
  245. -enableUndefinedBehaviorSanitizer YES
  246. )
  247. cmake_options+=(
  248. -DWITH_UBSAN=ON
  249. )
  250. ;;
  251. *)
  252. echo "Unknown sanitizer '$sanitizer'" 1>&2
  253. exit 1
  254. ;;
  255. esac
  256. done
  257. fi
  258. case "$product-$platform-$method" in
  259. FirebasePod-iOS-*)
  260. RunXcodebuild \
  261. -workspace 'CoreOnly/Tests/FirebasePodTest/FirebasePodTest.xcworkspace' \
  262. -scheme "FirebasePodTest" \
  263. "${xcb_flags[@]}" \
  264. build
  265. ;;
  266. Auth-*-*)
  267. if check_secrets; then
  268. RunXcodebuild \
  269. -project 'FirebaseAuth/Tests/SampleSwift/AuthenticationExample.xcodeproj' \
  270. -scheme "$method" \
  271. "${xcb_flags[@]}" \
  272. test
  273. fi
  274. ;;
  275. CombineSwift-*-xcodebuild)
  276. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  277. RunXcodebuild \
  278. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  279. -scheme "FirebaseCombineSwift-Unit-unit" \
  280. "${xcb_flags[@]}" \
  281. build \
  282. test
  283. ;;
  284. InAppMessaging-*-xcodebuild)
  285. RunXcodebuild \
  286. -workspace 'FirebaseInAppMessaging/Tests/Integration/DefaultUITestApp/InAppMessagingDisplay-Sample.xcworkspace' \
  287. -scheme 'FiamDisplaySwiftExample' \
  288. "${xcb_flags[@]}" \
  289. test
  290. ;;
  291. Firestore-*-xcodebuild)
  292. "${firestore_emulator}" start
  293. trap '"${firestore_emulator}" stop' ERR EXIT
  294. RunXcodebuild \
  295. -workspace 'Firestore/Example/Firestore.xcworkspace' \
  296. -scheme "Firestore_IntegrationTests_$platform" \
  297. -enableCodeCoverage YES \
  298. "${xcb_flags[@]}" \
  299. test
  300. ;;
  301. Firestore-macOS-cmake | Firestore-Linux-cmake)
  302. "${firestore_emulator}" start
  303. trap '"${firestore_emulator}" stop' ERR EXIT
  304. (
  305. test -d build || mkdir build
  306. cd build
  307. echo "Preparing cmake build ..."
  308. cmake -G Ninja "${cmake_options[@]}" ..
  309. echo "Building cmake build ..."
  310. ninja -k 10 all
  311. ctest --verbose
  312. )
  313. ;;
  314. SymbolCollision-*-*)
  315. RunXcodebuild \
  316. -workspace 'SymbolCollisionTest/SymbolCollisionTest.xcworkspace' \
  317. -scheme "SymbolCollisionTest" \
  318. "${xcb_flags[@]}" \
  319. build
  320. ;;
  321. # TODO(#12205) Restore this test to "test" instead of "build"
  322. Messaging-*-xcodebuild)
  323. pod_gen FirebaseMessaging.podspec --platforms=ios
  324. # Add GoogleService-Info.plist to generated Test Wrapper App.
  325. ruby ./scripts/update_xcode_target.rb gen/FirebaseMessaging/Pods/Pods.xcodeproj \
  326. AppHost-FirebaseMessaging-Unit-Tests \
  327. ../../../FirebaseMessaging/Tests/IntegrationTests/Resources/GoogleService-Info.plist
  328. if check_secrets; then
  329. # Integration tests are only run on iOS to minimize flake failures.
  330. RunXcodebuild \
  331. -workspace 'gen/FirebaseMessaging/FirebaseMessaging.xcworkspace' \
  332. -scheme "FirebaseMessaging-Unit-integration" \
  333. "${ios_flags[@]}" \
  334. "${xcb_flags[@]}" \
  335. build
  336. fi
  337. ;;
  338. MessagingSample-*-*)
  339. if check_secrets; then
  340. RunXcodebuild \
  341. -workspace 'FirebaseMessaging/Apps/Sample/Sample.xcworkspace' \
  342. -scheme "Sample" \
  343. "${xcb_flags[@]}" \
  344. build
  345. fi
  346. ;;
  347. SwiftUISample-*-*)
  348. if check_secrets; then
  349. RunXcodebuild \
  350. -workspace 'FirebaseMessaging/Apps/SwiftUISample/SwiftUISample.xcworkspace' \
  351. -scheme "SwiftUISample" \
  352. "${xcb_flags[@]}" \
  353. build
  354. fi
  355. ;;
  356. # TODO: This is actually building for iOS instead of watchOS. Update to use
  357. # watchOS xcb_flags along with the watchOS sdk option. Also nanopb and promises
  358. # podspecs need minimum version updates.
  359. MessagingSampleStandaloneWatchApp-*-*)
  360. if check_secrets; then
  361. RunXcodebuild \
  362. -workspace 'FirebaseMessaging/Apps/SampleStandaloneWatchApp/SampleStandaloneWatchApp.xcworkspace' \
  363. -scheme "SampleStandaloneWatchApp Watch App" \
  364. -destination 'platform=watchOS Simulator,name=Apple Watch Series 10 (42mm)' \
  365. build
  366. fi
  367. ;;
  368. MLModelDownloaderSample-*-*)
  369. if check_secrets; then
  370. RunXcodebuild \
  371. -workspace 'FirebaseMLModelDownloader/Apps/Sample/MLDownloaderTestApp.xcworkspace' \
  372. -scheme "MLDownloaderTestApp" \
  373. "${xcb_flags[@]}" \
  374. build
  375. fi
  376. ;;
  377. WatchOSSample-*-*)
  378. RunXcodebuild \
  379. -workspace 'Example/watchOSSample/SampleWatchApp.xcworkspace' \
  380. -scheme "SampleWatchAppWatchKitApp" \
  381. "${xcb_flags[@]}" \
  382. build
  383. ;;
  384. Database-*-integration)
  385. "${database_emulator}" start
  386. trap '"${database_emulator}" stop' ERR EXIT
  387. pod_gen FirebaseDatabase.podspec --platforms="${gen_platform}"
  388. RunXcodebuild \
  389. -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
  390. -scheme "FirebaseDatabase-Unit-integration" \
  391. "${xcb_flags[@]}" \
  392. build \
  393. test
  394. ;;
  395. RemoteConfig-*-fakeconsole)
  396. pod_gen FirebaseRemoteConfig.podspec --platforms="${gen_platform}"
  397. RunXcodebuild \
  398. -workspace 'gen/FirebaseRemoteConfig/FirebaseRemoteConfig.xcworkspace' \
  399. -scheme "FirebaseRemoteConfig-Unit-fake-console-tests" \
  400. "${xcb_flags[@]}" \
  401. build \
  402. test
  403. ;;
  404. RemoteConfig-*-integration)
  405. pod_gen FirebaseRemoteConfig.podspec --platforms="${gen_platform}"
  406. # Add GoogleService-Info.plist to generated Test Wrapper App.
  407. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfig/Pods/Pods.xcodeproj \
  408. AppHost-FirebaseRemoteConfig-Unit-Tests \
  409. ../../../FirebaseRemoteConfig/Tests/Swift/SwiftAPI/GoogleService-Info.plist
  410. # Add AccessToken to generated Test Wrapper App.
  411. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfig/Pods/Pods.xcodeproj \
  412. AppHost-FirebaseRemoteConfig-Unit-Tests \
  413. ../../../FirebaseRemoteConfig/Tests/Swift/AccessToken.json
  414. # Integration tests are only run on iOS to minimize flake failures.
  415. # TODO(ncooke3): Remove -sdk and -destination flags and replace with "${xcb_flags[@]}"
  416. RunXcodebuild \
  417. -workspace 'gen/FirebaseRemoteConfig/FirebaseRemoteConfig.xcworkspace' \
  418. -scheme "FirebaseRemoteConfig-Unit-swift-api-tests" \
  419. -sdk 'iphonesimulator' \
  420. -destination 'platform=iOS Simulator,name=iPhone 16,OS=18.3.1' \
  421. build \
  422. test
  423. ;;
  424. RemoteConfigSample-*-*)
  425. RunXcodebuild \
  426. -workspace 'FirebaseRemoteConfig/Tests/Sample/RemoteConfigSampleApp.xcworkspace' \
  427. -scheme "RemoteConfigSampleApp" \
  428. "${xcb_flags[@]}" \
  429. build
  430. ;;
  431. VertexIntegration-*-*)
  432. RunXcodebuild \
  433. -project 'FirebaseVertexAI/Tests/TestApp/VertexAITestApp.xcodeproj' \
  434. -scheme "VertexAITestApp-SPM" \
  435. "${xcb_flags[@]}" \
  436. -parallel-testing-enabled NO \
  437. build \
  438. test
  439. ;;
  440. Sessions-*-integration)
  441. # Perform "pod install" to install the relevant dependencies
  442. # ./FirebaseSessions/generate_testapp.sh
  443. pod_gen FirebaseSessions.podspec --platforms=ios --clean
  444. cd FirebaseSessions/Tests/TestApp; pod install; cd -
  445. # Run E2E Integration Tests for Prod.
  446. RunXcodebuild \
  447. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  448. -scheme "AppQualityDevApp_iOS" \
  449. "${ios_flags[@]}" \
  450. "${xcb_flags[@]}" \
  451. build \
  452. test
  453. # Run E2E Integration Tests for Staging.
  454. RunXcodebuild \
  455. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  456. -scheme "AppQualityDevApp_iOS" \
  457. FirebaseSessionsRunEnvironment=STAGING \
  458. "${ios_flags[@]}" \
  459. "${xcb_flags[@]}" \
  460. build \
  461. test
  462. # Run E2E Integration Tests for Autopush.
  463. RunXcodebuild \
  464. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  465. -scheme "AppQualityDevApp_iOS" \
  466. FirebaseSessionsRunEnvironment=AUTOPUSH \
  467. "${ios_flags[@]}" \
  468. "${xcb_flags[@]}" \
  469. build \
  470. test
  471. ;;
  472. StorageSwift-*-xcodebuild)
  473. pod_gen FirebaseStorage.podspec --platforms=ios
  474. # Add GoogleService-Info.plist to generated Test Wrapper App.
  475. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  476. AppHost-FirebaseStorage-Unit-Tests \
  477. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  478. if check_secrets; then
  479. # Integration tests are only run on iOS to minimize flake failures.
  480. # TODO(ncooke3): Add back "${ios_flags[@]}". See #14657.
  481. RunXcodebuild \
  482. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  483. -scheme "FirebaseStorage-Unit-integration" \
  484. -sdk 'iphonesimulator' \
  485. -destination 'platform=iOS Simulator,name=iPhone 16,OS=18.3.1' \
  486. "${xcb_flags[@]}" \
  487. test
  488. fi
  489. ;;
  490. StorageObjC-*-xcodebuild)
  491. pod_gen FirebaseStorage.podspec --platforms=ios
  492. # Add GoogleService-Info.plist to generated Test Wrapper App.
  493. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  494. AppHost-FirebaseStorage-Unit-Tests \
  495. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  496. if check_secrets; then
  497. # Integration tests are only run on iOS to minimize flake failures.
  498. # TODO(ncooke3): Add back "${ios_flags[@]}". See #14657.
  499. RunXcodebuild \
  500. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  501. -scheme "FirebaseStorage-Unit-ObjCIntegration" \
  502. -sdk 'iphonesimulator' \
  503. -destination 'platform=iOS Simulator,name=iPhone 16,OS=18.3.1' \
  504. "${xcb_flags[@]}" \
  505. test
  506. fi
  507. ;;
  508. StorageCombine-*-xcodebuild)
  509. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  510. # Add GoogleService-Info.plist to generated Test Wrapper App.
  511. ruby ./scripts/update_xcode_target.rb gen/FirebaseCombineSwift/Pods/Pods.xcodeproj \
  512. AppHost-FirebaseCombineSwift-Unit-Tests \
  513. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  514. if check_secrets; then
  515. # Integration tests are only run on iOS to minimize flake failures.
  516. RunXcodebuild \
  517. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  518. -scheme "FirebaseCombineSwift-Unit-integration" \
  519. "${ios_flags[@]}" \
  520. "${xcb_flags[@]}" \
  521. test
  522. fi
  523. ;;
  524. GoogleDataTransport-watchOS-xcodebuild)
  525. RunXcodebuild \
  526. -workspace 'GoogleDataTransport/GDTWatchOSTestApp/GDTWatchOSTestApp.xcworkspace' \
  527. -scheme "GDTWatchOSTestAppWatchKitApp" \
  528. "${xcb_flags[@]}" \
  529. build
  530. RunXcodebuild \
  531. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  532. -scheme "GDTCCTWatchOSIndependentTestAppWatchKitApp" \
  533. "${xcb_flags[@]}" \
  534. build
  535. RunXcodebuild \
  536. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  537. -scheme "GDTCCTWatchOSCompanionTestApp" \
  538. "${xcb_flags[@]}" \
  539. build
  540. ;;
  541. Performance-*-unit)
  542. # Run unit tests on prod environment with unswizzle capabilities.
  543. export FPR_UNSWIZZLE_AVAILABLE="1"
  544. export FPR_AUTOPUSH_ENV="0"
  545. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  546. RunXcodebuild \
  547. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  548. -scheme "FirebasePerformance-Unit-unit" \
  549. "${xcb_flags[@]}" \
  550. build \
  551. test
  552. ;;
  553. Performance-*-proddev)
  554. # Build the prod dev test app.
  555. export FPR_UNSWIZZLE_AVAILABLE="0"
  556. export FPR_AUTOPUSH_ENV="0"
  557. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  558. RunXcodebuild \
  559. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  560. -scheme "FirebasePerformance-TestApp" \
  561. "${xcb_flags[@]}" \
  562. build
  563. ;;
  564. Performance-*-integration)
  565. # Generate the workspace for the SDK to generate Protobuf files.
  566. export FPR_UNSWIZZLE_AVAILABLE="0"
  567. pod_gen FirebasePerformance.podspec --platforms=ios --clean
  568. # Perform "pod install" to install the relevant dependencies
  569. cd FirebasePerformance/Tests/FIRPerfE2E; pod install; cd -
  570. # Run E2E Integration Tests for Autopush.
  571. RunXcodebuild \
  572. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  573. -scheme "FIRPerfE2EAutopush" \
  574. FPR_AUTOPUSH_ENV=1 \
  575. "${ios_flags[@]}" \
  576. "${xcb_flags[@]}" \
  577. build \
  578. test
  579. # Run E2E Integration Tests for Prod.
  580. RunXcodebuild \
  581. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  582. -scheme "FIRPerfE2EProd" \
  583. "${ios_flags[@]}" \
  584. "${xcb_flags[@]}" \
  585. build \
  586. test
  587. ;;
  588. FirebaseDataConnect-*-spm)
  589. RunXcodebuild \
  590. -scheme $product \
  591. "${xcb_flags[@]}" \
  592. IPHONEOS_DEPLOYMENT_TARGET=15.0 \
  593. TVOS_DEPLOYMENT_TARGET=15.0 \
  594. test
  595. ;;
  596. # Note that the combine tests require setting the minimum iOS and tvOS version to 13.0
  597. *-*-spm)
  598. RunXcodebuild \
  599. -scheme $product \
  600. "${xcb_flags[@]}" \
  601. IPHONEOS_DEPLOYMENT_TARGET=13.0 \
  602. TVOS_DEPLOYMENT_TARGET=13.0 \
  603. test
  604. ;;
  605. *-*-spmbuildonly)
  606. RunXcodebuild \
  607. -scheme $product \
  608. "${xcb_flags[@]}" \
  609. build
  610. ;;
  611. ClientApp-iOS-xcodebuild | ClientApp-iOS13-iOS-xcodebuild)
  612. RunXcodebuild \
  613. -project 'IntegrationTesting/ClientApp/ClientApp.xcodeproj' \
  614. -scheme $product \
  615. "${xcb_flags[@]}" \
  616. build
  617. ;;
  618. ClientApp-CocoaPods*-iOS-xcodebuild)
  619. RunXcodebuild \
  620. -workspace 'IntegrationTesting/ClientApp/ClientApp.xcworkspace' \
  621. -scheme $product \
  622. "${xcb_flags[@]}" \
  623. build
  624. ;;
  625. *)
  626. echo "Don't know how to build this product-platform-method combination" 1>&2
  627. echo " product=$product" 1>&2
  628. echo " platform=$platform" 1>&2
  629. echo " method=$method" 1>&2
  630. exit 1
  631. ;;
  632. esac